package com.realnet.basic.Controllers;
import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
 import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import com.fasterxml.jackson.core.JsonProcessingException;
import org.springframework.web.bind.annotation.CrossOrigin;
import com.fasterxml.jackson.databind.JsonMappingException;
import com.realnet.config.EmailService;
import com.realnet.users.entity1.AppUser;
import com.realnet.users.service1.AppUserServiceImpl;
import com.fasterxml.jackson.databind.ObjectMapper;
import org.springframework.data.domain.*;
import com.realnet.fnd.response.EntityResponse;
import org.springframework.http.*;
import org.springframework.beans.factory.annotation.*;
import com.realnet.basic.Entity.Journal;
import com.realnet.basic.Services.JournalService ;






@RequestMapping(value = "/Journal")
 @CrossOrigin("*") 
@RestController
public class JournalController {
	@Autowired
	private JournalService Service;

@Value("${projectPath}")
	private String projectPath;
 






	@PostMapping("/Journal")
		  public Journal Savedata(@RequestBody Journal data) {
		Journal save = Service.Savedata(data)	;





		System.out.println("data saved..." + save);

 return save;
	  }
@PutMapping("/Journal/{id}")
	public  Journal update(@RequestBody Journal data,@PathVariable Integer id ) {
		Journal update = Service.update(data,id);
		System.out.println("data update..." + update);
		return update;
	}	 
//	get all with pagination
	@GetMapping("/Journal/getall/page")
	public Page<Journal> getall(@RequestParam(value = "page", required = false) Integer page,
			@RequestParam(value = "size", required = false) Integer size) {
		Pageable paging = PageRequest.of(page, size);
		Page<Journal> get = Service.getAllWithPagination(paging);

		return get;

	}	
	@GetMapping("/Journal")
	public List<Journal> getdetails() {
		 List<Journal> get = Service.getdetails();		
		return get;
}
// get all without authentication 

	@GetMapping("/token/Journal")
	public List<Journal> getallwioutsec() {
		 List<Journal> get = Service.getdetails();		
		return get;
}
@GetMapping("/Journal/{id}")
	public  Journal  getdetailsbyId(@PathVariable Integer id ) {
		Journal  get = Service.getdetailsbyId(id);
		return get;
	}
@DeleteMapping("/Journal/{id}")
	public  ResponseEntity<?> delete_by_id(@PathVariable Integer id ) {
	Service.delete_by_id(id);
			return new ResponseEntity<>(new EntityResponse("Deleted"), HttpStatus.OK);
	
	}







}